#include "mex.h"
#include "distances.h"
#include <math.h>



void mexFunction(int nlhs, mxArray *plhs[],
		 int nrhs, const mxArray *prhs[]) {

  int i,j,num,dim,k,index_out1,index_out2;
  double* points, *outArray;
  double norm;

  // Test number of parameters.
  if ((nrhs != 1 && nrhs!=4) || nlhs != 1) {
    mexWarnMsgTxt("Usage: K = getDistanceMatrix(Points) or if you want to compute the tangent distance,\n K = getDistanceMatrix(Points,sides,choice,background)");
    return;
  }

  // Parse parameters
  dim = (int)mxGetM(prhs[0]);
  num = (int)mxGetN(prhs[0]);
  points = mxGetPr(prhs[0]);
  index_out1=0; index_out2=0;

  // Allocate memory for output
  plhs[0] = mxCreateDoubleMatrix(num, num, mxREAL);
  outArray = mxGetPr(plhs[0]);

  // Compute Distance Matrix
  for(i=0; i<num; i++) {
    //outArray[i*num+i] = 0;
    index_out1 += i;
    index_out2=index_out1+num;
    outArray[index_out1] = 0;
    for(j=(i+1); j<num; j++)
    {
      norm = EuclideanDist(points,i,j,dim);

      // Write distance
      index_out1++;
      outArray[index_out1] = norm;
      outArray[index_out2] = norm;

      //printf("out1: %i, out2: %i\n",index_out1,index_out2);
      index_out2+=num;
    }
    index_out1++;
  }
}